## xrootd 5.9.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16...3.31 FATAL_ERROR)

# Check for in-source builds
if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
  message(FATAL_ERROR "XRootD cannot be built in-source! "
                      "Please run cmake <src-dir> outside the "
                      "source directory and be sure to remove "
                      "CMakeCache.txt or CMakeFiles if they "
                      "exist in the source directory.")
endif()

project( XRootD )

set( CMAKE_MODULE_PATH
 ${PROJECT_SOURCE_DIR}/src
 ${PROJECT_SOURCE_DIR}/cmake )

# Place build artifacts in ${CMAKE_BINARY_DIR}/{bin,lib}
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin CACHE PATH "")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib CACHE PATH "")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib CACHE PATH "")

include(XRootDVersion)

#-------------------------------------------------------------------------------
# A 'plugins' phony target to simplify building build-tree binaries.
# Plugins are responsible for adding themselves to this target, where
# appropriate.
#-------------------------------------------------------------------------------
ADD_CUSTOM_TARGET(plugins)

include(GNUInstallDirs)

include( XRootDOSDefs )
include( XRootDDefaults )
include( XRootDSystemCheck )
include( XRootDFindLibs )

#-------------------------------------------------------------------------------
# Generate the version header
#-------------------------------------------------------------------------------

configure_file(src/XrdVersion.hh.in src/XrdVersion.hh)

#-------------------------------------------------------------------------------
# Build in subdirectories
#-------------------------------------------------------------------------------

include_directories(BEFORE ${PROJECT_SOURCE_DIR}/src ${PROJECT_BINARY_DIR}/src)

include(CTest)

add_subdirectory(src)
add_subdirectory(bindings)
add_subdirectory(tests)

add_subdirectory(docs)
add_subdirectory(utils)

include( XRootDSummary )


#-------------------------------------------------------------------------------
# Install XRootDConfig.cmake module
#-------------------------------------------------------------------------------

include(CMakePackageConfigHelpers)

write_basic_package_version_file(cmake/${PROJECT_NAME}ConfigVersion.cmake
  VERSION ${XRootD_VERSION} COMPATIBILITY SameMajorVersion)

configure_package_config_file(cmake/${PROJECT_NAME}Config.cmake.in cmake/${PROJECT_NAME}Config.cmake
  INSTALL_PREFIX
    ${CMAKE_INSTALL_PREFIX}
  INSTALL_DESTINATION
    ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
  PATH_VARS
    CMAKE_INSTALL_BINDIR
    CMAKE_INSTALL_INCLUDEDIR
    CMAKE_INSTALL_LIBDIR
    CMAKE_INSTALL_DATADIR
)

install(DIRECTORY ${PROJECT_BINARY_DIR}/cmake/
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})

#-------------------------------------------------------------------------------
# Configure an 'uninstall' target
#-------------------------------------------------------------------------------
CONFIGURE_FILE(
	"${CMAKE_CURRENT_SOURCE_DIR}/cmake/uninstall.cmake.in"
	"${CMAKE_CURRENT_BINARY_DIR}/cmake/uninstall.cmake"
	IMMEDIATE @ONLY)

ADD_CUSTOM_TARGET(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake/uninstall.cmake")

=== bindings/CMakeLists.txt ===

if( BUILD_PYTHON )
  add_subdirectory( python )
endif()

=== docs/CMakeLists.txt ===

add_subdirectory(man)

=== src/CMakeLists.txt ===
#-------------------------------------------------------------------------------
# If this is a build for pip set up the rpath
# (this is especially important for plugins)
#-------------------------------------------------------------------------------
if( PYPI_BUILD )
  set( CMAKE_INSTALL_RPATH "$ORIGIN" )
  set( CMAKE_INSTALL_RPATH_USE_LINK_PATH true )
endif()

#-------------------------------------------------------------------------------
# XRDCL_LIB_ONLY implies XRDCL_ONLY
#-------------------------------------------------------------------------------
if( XRDCL_LIB_ONLY )
  set ( XRDCL_ONLY TRUE )
endif()

include( XrdHeaders )

add_library(XrdUtils SHARED)

set_target_properties(XrdUtils
  PROPERTIES BUILD_RPATH $ORIGIN VERSION 3.0.0 SOVERSION 3
)

target_link_libraries(XrdUtils
  PRIVATE
    OpenSSL::SSL
    ${CMAKE_THREAD_LIBS_INIT}
    ${CMAKE_DL_LIBS}
    ${SOCKET_LIBRARY}
    ${SENDFILE_LIBRARY}
    ${EXTRA_LIBS}
)

if(SYSTEMD_FOUND)
  target_link_libraries(XrdUtils PRIVATE ${SYSTEMD_LIBRARIES})
endif()

install(TARGETS XrdUtils LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

add_subdirectory( XProtocol )
add_subdirectory( Xrd )
add_subdirectory( XrdCks )
add_subdirectory( XrdNet )
add_subdirectory( XrdSut )
add_subdirectory( XrdSys )
add_subdirectory( XrdOuc )
add_subdirectory( XrdTls )
add_subdirectory( XrdRmc )

add_subdirectory( XrdApps )
add_subdirectory( XrdCrypto )
add_subdirectory( XrdPosix )

add_subdirectory( XrdSec )
add_subdirectory( XrdSecgsi )
add_subdirectory( XrdSeckrb5 )
add_subdirectory( XrdSecpwd )
add_subdirectory( XrdSecsss )
add_subdirectory( XrdSecunix )
add_subdirectory( XrdSecztn )

add_subdirectory( XrdXml )

add_subdirectory( XrdCl )
add_subdirectory( XrdClHttp )
add_subdirectory( XrdEc )

if( NOT XRDCL_ONLY )
  add_library(XrdServer SHARED)

  set_target_properties(XrdServer
    PROPERTIES VERSION 3.0.0 SOVERSION 3
  )

  target_link_libraries(XrdServer
    PRIVATE
    XrdUtils
    ${CMAKE_DL_LIBS}
    ${CMAKE_THREAD_LIBS_INIT}
    ${ATOMIC_LIBRARY}
    ${EXTRA_LIBS}
    ${SOCKET_LIBRARY}
  )

  install(TARGETS XrdServer LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

  add_subdirectory( XrdAcc )
  add_subdirectory( XrdCms )
  add_subdirectory( XrdDig )
  add_subdirectory( XrdFrc )
  add_subdirectory( XrdOfs )
  add_subdirectory( XrdOss )
  add_subdirectory( XrdSfs )
  add_subdirectory( XrdXrootd )

  add_subdirectory( XrdFrm )
  add_subdirectory( XrdFfs )
  add_subdirectory( XrdBwm )
  add_subdirectory( XrdPss )
  add_subdirectory( XrdSsi )
  add_subdirectory( XrdPfc )
  add_subdirectory( XrdOssCsi )
  add_subdirectory( XrdOssStats )
  add_subdirectory( XrdThrottle )

  add_subdirectory( XrdHttp )
  add_subdirectory( XrdHttpTpc )

  add_subdirectory( XrdMacaroons )
  add_subdirectory( XrdVoms )
  add_subdirectory( XrdHttpCors )
  add_subdirectory( XrdCeph )
  add_subdirectory( XrdSciTokens )
endif()

=== tests/CMakeLists.txt ===
if(NOT BUILD_TESTS)
  return()
endif()

include(GoogleTest)

add_subdirectory(common)

add_subdirectory(XrdCl)
add_subdirectory(XrdCeph)
add_subdirectory(XrdEc)
add_subdirectory(XrdPosix)

add_subdirectory(XrdHttpTests)

add_subdirectory(XrdOucTests)

add_subdirectory( XrdSsiTests )

add_subdirectory(XrdHttpTpc)

add_subdirectory(XrdPfcTests)

if( BUILD_SCITOKENS )
  add_subdirectory( scitokens )
endif()

if(NOT ENABLE_SERVER_TESTS)
  return()
endif()

add_subdirectory( XrdOssTests )
add_subdirectory( XRootD )
add_subdirectory( cluster )
add_subdirectory( authenticated_cluster)
add_subdirectory( stress )
add_subdirectory( TPCTests )
add_subdirectory( badredir )
add_subdirectory( xcachewithcsi )

=== utils/CMakeLists.txt ===
if( NOT XRDCL_LIB_ONLY )
  configure_file(xrootd-config xrootd-config @ONLY)
  install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/xrootd-config DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

if( NOT XRDCL_ONLY )
  install(PROGRAMS
    XrdCmsNotify.pm
    netchk
    XrdOlbMonPerf
    cms_monPerf
    xrdcp-tpc.sh
    DESTINATION ${CMAKE_INSTALL_DATADIR}/xrootd/utils)
endif()

=== bindings/python/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16...3.31 FATAL_ERROR)

project(PyXRootD LANGUAGES CXX)

if( CMAKE_VERSION VERSION_LESS 3.18 )
  set(PYTHON_COMPONENTS Interpreter Development)
else()
  set(PYTHON_COMPONENTS Interpreter Development.Module)
endif()

find_package(Python REQUIRED COMPONENTS ${PYTHON_COMPONENTS})

if(CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR OR PYPI_BUILD)
  add_subdirectory(src)
else()
  configure_file(setup.py setup.py)
  file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/VERSION "${XRootD_VERSION_STRING}")

  option(INSTALL_PYTHON_BINDINGS "Install Python bindings" TRUE)

  if(INSTALL_PYTHON_BINDINGS)
    set(PIP_OPTIONS "" CACHE STRING "Install options for pip")

    install(CODE "
      execute_process(COMMAND ${Python_EXECUTABLE} -m pip install ${PIP_OPTIONS}
        --prefix \$ENV{DESTDIR}${CMAKE_INSTALL_PREFIX} ${CMAKE_CURRENT_BINARY_DIR}
        RESULT_VARIABLE INSTALL_STATUS COMMAND_ECHO STDOUT)
      if(NOT INSTALL_STATUS EQUAL 0)
        message(FATAL_ERROR \"Failed to install Python bindings\")
      endif()
    ")
  endif()
endif()

=== docs/man/CMakeLists.txt ===
if( XRDCL_LIB_ONLY )
  return()
endif()

set(MAN1PAGES
  xrdcp.1
  xrdfs.1
  xrdmapc.1
)

set(MAN8PAGES
    cmsd.8
    frm_admin.8
    frm_purged.8
    frm_xfragent.8
    frm_xfrd.8
    mpxstats.8
    xrdpfc_print.8
    xrdpwdadmin.8
    xrdsssadmin.8
    xrootd.8
)

if ( BUILD_FUSE )
  list(APPEND MAN1PAGES xrootdfs.1)
endif()

if ( NOT XRDCL_ONLY )
  list(APPEND MAN1PAGES xrdadler32.1 xrdgsiproxy.1 xrdgsitest.1)

  foreach(MAN ${MAN8PAGES})
    configure_file(${MAN} man8/${MAN} @ONLY)
  endforeach()

  install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/man8
          DESTINATION ${CMAKE_INSTALL_MANDIR})

  if( BUILD_VOMS )
    list(APPEND MAN1PAGES libXrdVoms.1)
  endif()
endif()

foreach(MAN ${MAN1PAGES})
  configure_file(${MAN} man1/${MAN} @ONLY)
endforeach()

install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/man1
        DESTINATION ${CMAKE_INSTALL_MANDIR})

install(CODE
  "execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink xrdcp.1 xrdcopy.1
     WORKING_DIRECTORY \$ENV{DESTDIR}/${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_MANDIR}/man1)")

if( BUILD_VOMS )
  install(CODE
    "execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink libXrdVoms.1 libXrdSecgsiVOMS.1
       WORKING_DIRECTORY \$ENV{DESTDIR}/${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_MANDIR}/man1)")
endif()

=== src/XProtocol/CMakeLists.txt ===
target_sources(XrdUtils
  PRIVATE
    XProtocol.hh
    XProtocol.cc
)

=== src/Xrd/CMakeLists.txt ===
target_sources(XrdUtils
  PRIVATE
    XrdBuffer.cc     XrdBuffer.hh
    XrdBuffXL.cc     XrdBuffXL.hh
    XrdInet.cc       XrdInet.hh
    XrdInfo.cc       XrdInfo.hh
    XrdJob.hh
    XrdLink.cc       XrdLink.hh
    XrdLinkCtl.cc    XrdLinkCtl.hh
                     XrdLinkInfo.hh
    XrdLinkXeq.cc    XrdLinkXeq.hh
    XrdLinkMatch.cc  XrdLinkMatch.hh
    XrdGlobals.cc
    XrdMonitor.cc    XrdMonRoll.hh
    XrdMonRoll.cc    XrdMonRoll.hh
    XrdObject.icc    XrdObject.hh
    XrdPoll.cc       XrdPoll.hh
                     XrdPollE.hh
                     XrdPollE.icc
                     XrdPollInfo.hh
                     XrdPollPoll.hh
                     XrdPollPoll.icc
                     XrdProtocol.hh
    XrdScheduler.cc  XrdScheduler.hh
    XrdSendQ.cc      XrdSendQ.hh
                     XrdTrace.hh
)

if(XRDCL_ONLY)
  return()
endif()

add_executable(xrootd
  XrdConfig.cc    XrdConfig.hh
  XrdProtLoad.cc  XrdProtLoad.hh
  XrdStats.cc     XrdStats.hh
  XrdMain.cc
)

target_link_libraries(xrootd
  XrdServer
  XrdUtils
  ${CMAKE_DL_LIBS}
  ${CMAKE_THREAD_LIBS_INIT}
  ${EXTRA_LIBS}
  ${SOCKET_LIBRARY}
)

install(TARGETS xrootd RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== src/XrdAcc/CMakeLists.txt ===
#-----------------------------------------------------------------------------
# XrdAcc - Authorization
#-----------------------------------------------------------------------------

target_sources(XrdServer
  PRIVATE
    XrdAccAccess.cc      XrdAccAccess.hh
    XrdAccAudit.cc       XrdAccAudit.hh
                         XrdAccAuthDB.hh
                         XrdAccAuthorize.hh
    XrdAccAuthFile.cc    XrdAccAuthFile.hh
    XrdAccCapability.cc  XrdAccCapability.hh
    XrdAccConfig.cc      XrdAccConfig.hh
    XrdAccEntity.cc      XrdAccEntity.hh
    XrdAccGroups.cc      XrdAccGroups.hh
                         XrdAccPrivs.hh
)

=== src/XrdApps/CMakeLists.txt ===
add_library(XrdAppUtils SHARED
  XrdCpConfig.cc  XrdCpConfig.hh
  XrdCpFile.cc    XrdCpFile.hh
  XrdMpxXml.cc    XrdMpxXml.hh
)

target_link_libraries(XrdAppUtils PRIVATE XrdUtils)

set_target_properties(XrdAppUtils
  PROPERTIES VERSION 2.0.0 SOVERSION 2)

set(XrdClProxyPlugin XrdClProxyPlugin-${PLUGIN_VERSION})

add_library(${XrdClProxyPlugin} MODULE
  XrdClProxyPlugin/ProxyPrefixPlugin.cc
  XrdClProxyPlugin/ProxyPrefixFile.cc
)

target_link_libraries(${XrdClProxyPlugin} PRIVATE XrdCl)

set(XrdClRecorder XrdClRecorder-${PLUGIN_VERSION})

add_library(${XrdClRecorder} MODULE
  XrdClRecordPlugin/XrdClRecorderPlugin.cc
)

target_link_libraries(${XrdClRecorder} PRIVATE XrdCl)

add_executable(xrdreplay XrdClRecordPlugin/XrdClReplay.cc)

target_link_libraries(xrdreplay
  XrdCl
  XrdUtils 
  ${CMAKE_THREAD_LIBS_INIT}
)

install(
  TARGETS
    xrdreplay
    XrdAppUtils
    ${XrdClProxyPlugin}
    ${XrdClRecorder}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

if(NOT XRDCL_ONLY)
  add_executable(cconfig XrdAppsCconfig.cc)
  target_link_libraries(cconfig XrdUtils)

  add_executable(mpxstats XrdMpxStats.cc)
  target_link_libraries(
    mpxstats
    XrdAppUtils
    XrdUtils
    ${EXTRA_LIBS}
    ${CMAKE_THREAD_LIBS_INIT}
    ${SOCKET_LIBRARY}
  )

  add_executable(wait41 XrdWait41.cc)
  target_link_libraries(wait41
    XrdUtils
    ${CMAKE_THREAD_LIBS_INIT}
    ${EXTRA_LIBS}
  )

  add_executable(xrdacctest XrdAccTest.cc)
  target_link_libraries(xrdacctest XrdServer XrdUtils)

  add_executable(xrdadler32 Xrdadler32.cc)
  target_link_libraries(xrdadler32
    XrdPosix
    XrdUtils
    ZLIB::ZLIB
    ${CMAKE_THREAD_LIBS_INIT}
  )

  add_executable(xrdcks XrdCks.cc)
  target_link_libraries(xrdcks XrdUtils)

  add_executable(xrdcrc32c XrdCrc32c.cc)
  target_link_libraries(xrdcrc32c XrdUtils)

  add_executable(xrdmapc XrdMapCluster.cc)
  target_link_libraries(xrdmapc XrdCl XrdUtils)

  add_executable(xrdpinls XrdPinls.cc)

  add_executable(xrdprep XrdPrep.cc)
  target_link_libraries(xrdprep XrdCl XrdUtils)

  add_executable(xrdqstats XrdQStats.cc)
  target_link_libraries(xrdqstats
    XrdCl
    XrdAppUtils
    XrdUtils
    ${EXTRA_LIBS}
  )

  install(
    TARGETS
      cconfig
      mpxstats
      wait41
      xrdacctest
      xrdadler32
      xrdcks
      xrdcrc32c
      xrdmapc
      xrdpinls
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  )
endif()

=== debian/changelog ===
xrootd (5.9.0-1) unstable; urgency=medium

  * Update to version 5.9.0
  * Add Build-Depends libcrypt-dev (Closes: #1107063)

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Sat, 11 Oct 2025 14:07:08 +0200

=== debian/control ===
Source: xrootd
Section: net
Priority: optional
Standards-Version: 4.7.2
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-installsysusers,
 dpkg-dev (>= 1.22.5),
 dh-python,
 cmake,
 pkgconf,
 libfuse-dev [linux-any kfreebsd-any],
 libkrb5-dev,
 libcurl4-openssl-dev,
 libtinyxml-dev,
 libxml2-dev,
 ncurses-dev,
 libssl-dev,
 libreadline-dev,
 zlib1g-dev,
 libsystemd-dev [linux-any],
 pybuild-plugin-pyproject,
 python3-dev,
 python3-pip,
 python3-setuptools,
 python3-wheel,
 libjson-c-dev,
 libmacaroons-dev,
 uuid-dev,
 voms-dev,
 libscitokens-dev,
 davix-dev,
 libcrypt-dev,
 librados-dev [amd64 arm64 loong64 mips64el ppc64el riscv64 s390x],
 libradospp-dev [amd64 arm64 loong64 mips64el ppc64el riscv64 s390x],
 libradosstriper-dev [amd64 arm64 loong64 mips64el ppc64el riscv64 s390x],
 libisal-dev [amd64 arm64 mips64el ppc64el riscv64 s390x alpha hurd-amd64 loong64 ppc64 sparc64],
 attr,
 curl,
 davix,
 libgtest-dev,
 openssl,
 procps,
 uuid-runtime
Build-Depends-Indep:
 dh-sequence-sphinxdoc,
 doxygen,
 graphviz,
 python3-sphinx
Homepage: https://xrootd.web.cern.ch/
Maintainer: Mattias Ellert <mattias.ellert@physics.uu.se>
Vcs-Browser: https://salsa.debian.org/ellert/xrootd
Vcs-Git: https://salsa.debian.org/ellert/xrootd.git

Package: xrootd-server
Architecture: any
Multi-Arch: foreign
Depends:
 xrootd-plugins (= ${binary:Version}),
 xrootd-server-plugins (= ${binary:Version}),
 expect,
 logrotate,
 ${perl:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Description: Extended ROOT file server
 The Extended root file server consists of a file server called xrootd
 and a cluster management server called cmsd.
 .
 The xrootd server was developed for the root analysis framework to
 serve root files. However, the server is agnostic to file types and
 provides POSIX-like access to any type of file.
 .
 The cmsd server is the next generation version of the olbd server,
 originally developed to cluster and load balance Objectivity/DB AMS
 database servers. It provides enhanced capability along with lower
 latency and increased throughput.

Package: libxrdapputils2t64
Provides: ${t64:Provides}
Replaces: libxrdapputils2
Breaks: libxrdapputils2 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Utilities library for xrootd applications
 This package contains the xrootd utilities library for applications.

Package: libxrdcrypto2t64
Provides: ${t64:Provides}
Replaces: libxrdcrypto2
Breaks: libxrdcrypto2 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Cryptograpic library for xrootd
 This package contains the xrootd cryptograpic library.

Package: libxrdcryptolite2t64
Provides: ${t64:Provides}
Replaces: libxrdcryptolite2
Breaks: libxrdcryptolite2 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Light version of cryptograpic library for xrootd
 This package contains the light version of the xrootd cryptograpic library.

Package: libxrdutils3t64
Provides: ${t64:Provides}
Replaces:
 libxrdutils3,
 libxrdcephposix0 [i386 armel armhf mips mipsel powerpc],
 xrootd-ceph-plugins [i386 armel armhf mips mipsel powerpc],
 libxrdec1t64 [armel armhf m68k sh4],
 libxrdec1 [armel armhf m68k sh4]
Breaks:
 libxrdutils3 (<< ${source:Version}),
 libxrdcephposix0 [i386 armel armhf mips mipsel powerpc],
 xrootd-ceph-plugins [i386 armel armhf mips mipsel powerpc],
 libxrdec1t64 [armel armhf m68k sh4],
 libxrdec1 [armel armhf m68k sh4]
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Utilities library for xrootd
 This package contains the xrootd utilities library.

Package: libxrdxml3t64
Provides: ${t64:Provides}
Replaces: libxrdxml3
Breaks: libxrdxml3 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: XML library for xrootd
 This package contains the xrootd XML library.

Package: xrootd-plugins
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Plugins used by xrootd servers and clients
 This package contains plugins used by the xrootd servers and clients.

Package: libxrootd-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libxrdapputils2t64 (= ${binary:Version}),
 libxrdcrypto2t64 (= ${binary:Version}),
 libxrdcryptolite2t64 (= ${binary:Version}),
 libxrdutils3t64 (= ${binary:Version}),
 libxrdxml3t64 (= ${binary:Version}),
 ${misc:Depends}
Description: Development files for xrootd
 This package contains header files and development libraries for xrootd
 development.

Package: libxrdcl3t64
Provides: ${t64:Provides}
Replaces: libxrdcl3
Breaks: libxrdcl3 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Recommends:
 xrootd-plugins (= ${binary:Version}),
 xrootd-client-plugins(= ${binary:Version})
Description: Client library for xrootd
 This package contains the xrootd client library.

Package: libxrdec1t64
Provides: ${t64:Provides}
Replaces: libxrdec1
Breaks: libxrdec1 (<< ${source:Version})
Architecture: amd64 arm64 mips64el ppc64el riscv64 s390x alpha hurd-amd64 loong64 ppc64 sparc64
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Erasure code library for xrootd
 This package contains the xrootd erasure code library.

Package: libxrdffs3t64
Provides: ${t64:Provides}
Replaces: libxrdffs3
Breaks: libxrdffs3 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: File protocol library for xrootd
 This package contains the xrootd file protocol library.

Package: libxrdposix3t64
Provides: ${t64:Provides}
Replaces: libxrdposix3
Breaks: libxrdposix3 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Posix interface library for xrootd
 This package contains the xrootd Posix interface library.

Package: libxrdssilib2t64
Provides: ${t64:Provides}
Replaces: libxrdssilib2
Breaks: libxrdssilib2 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Server internals library for xrootd
 This package contains an xrootd server internals library.

Package: libxrdssishmap2t64
Provides: ${t64:Provides}
Replaces: libxrdssishmap2
Breaks: libxrdssishmap2 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Server internals library for xrootd
 This package contains an xrootd server internals library.

Package: xrootd-client-plugins
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Plugins used by xrootd clients
 This package contains plugins used by xrootd clients.

Package: xrootd-client-http-plugins
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: HTTP client plugin for XRootD client
 This package contains an XRootD client plugin which allows XRootD to
 interact with HTTP repositories.

Package: libxrootd-client-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libxrdcl3t64 (= ${binary:Version}),
 libxrdffs3t64 (= ${binary:Version}),
 libxrdposix3t64 (= ${binary:Version}),
 libxrootd-dev (= ${binary:Version}),
 ${misc:Depends}
Description: Development files for xrootd clients
 This package contains header files and development libraries for xrootd
 client development.

Package: libxrdhttputils2t64
Provides: ${t64:Provides}
Replaces: libxrdhttputils2
Breaks: libxrdhttputils2 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: HTTP protocol utilities library for xrootd
 This package contains the xrootd HTTP protocol utilities library.

Package: libxrdserver3t64
Provides: ${t64:Provides}
Replaces: libxrdserver3
Breaks: libxrdserver3 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Recommends:
 xrootd-plugins (= ${binary:Version}),
 xrootd-server-plugins(= ${binary:Version})
Description: Server library for xrootd
 This package contains the xrootd server library.

Package: xrootd-server-plugins
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Plugins used by xrootd servers
 This package contains plugins used by xrootd servers.

Package: libxrootd-server-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libxrdhttputils2t64 (= ${binary:Version}),
 libxrdserver3t64 (= ${binary:Version}),
 libxrootd-dev (= ${binary:Version}),
 libxrootd-client-dev (= ${binary:Version}),
 ${misc:Depends}
Description: Development files for xrootd servers
 This package contains header files and development libraries for xrootd
 server development.

Package: libxrootd-private-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libxrdec1t64 (= ${binary:Version}) [amd64 arm64 mips64el ppc64el riscv64 s390x alpha hurd-amd64 loong64 ppc64 sparc64],
 libxrdssilib2t64 (= ${binary:Version}),
 libxrdssishmap2t64 (= ${binary:Version}),
 libxrootd-dev (= ${binary:Version}),
 libxrootd-client-dev (= ${binary:Version}),
 libxrootd-server-dev (= ${binary:Version}),
 ${misc:Depends}
Description: Private xrootd headers
 This package contains some private xrootd headers. Backward and forward
 compatibility between versions is not guaranteed for these headers.

Package: xrootd-client
Architecture: any
Multi-Arch: foreign
Depends:
 xrootd-plugins (= ${binary:Version}),
 xrootd-client-plugins(= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: Xrootd command line client tools
 This package contains the command line tools used to communicate with
 xrootd servers.

Package: xrootd-fuse
Architecture: linux-any kfreebsd-any
Multi-Arch: foreign
Depends:
 xrootd-plugins (= ${binary:Version}),
 xrootd-client-plugins (= ${binary:Version}),
 fuse3 (>= 3.10.1-3) | fuse (<< 3),
 ${shlibs:Depends},
 ${misc:Depends}
Description: Xrootd FUSE tool
 This package contains the FUSE (file system in user space) xrootd mount
 tool.

Package: xrootd-voms-plugins
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: VOMS attribute extractor plugin for XRootD
 This package contains the xrootd VOMS attribute extractor plugin.

Package: xrootd-scitokens-plugins
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: SciTokens authorization support for XRootD
 This ACC (authorization) plugin for the XRootD framework utilizes the
 SciTokens library to validate and extract authorization claims from a
 SciToken passed during a transfer. Configured appropriately, this
 allows the XRootD server admin to delegate authorization decisions for
 a subset of the namespace to an external issuer.

Package: libxrdcephposix0
Architecture: amd64 arm64 loong64 mips64el ppc64el riscv64 s390x
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Ceph posix library for xrootd
 This package contains an xrootd library used by the ceph plugins.

Package: xrootd-ceph-plugins
Architecture: amd64 arm64 loong64 mips64el ppc64el riscv64 s390x
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: XRootD plugin for interfacing with the Ceph storage platform
 The xrootd-ceph is an OSS layer plugin for the XRootD server for
 interfacing with the Ceph storage platform.

Package: python3-xrootd
Architecture: any
Multi-Arch: foreign
Section: python
Provides:
 ${python3:Provides}
Depends:

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Disable ceph dependent packages for architectures without ceph
# This list should match the Build-Depends on ceph libraries in debian/control
#
# Ceph requires boost-context and boost-coroutine
# These are only available on these Debian architectures:
#   i386 hurd-i386 amd64 hurd-amd64 armel armhf arm64 loong64
#   mips mipsel mips64el powerpc ppc64el riscv64 s390x
#
# Ceph requires Java
# Java is not available on these Debian architectures:
#   hppa hurd-i386 hurd-amd64
#
# Ceph only supports 64 bit architectures
ifneq ($(filter $(DEB_HOST_ARCH),amd64 arm64 loong64 mips64el ppc64el riscv64 s390x),)
CEPH = ON
else
CEPH = OFF
endif

ifneq ($(filter $(DEB_HOST_ARCH_OS),linux kfreebsd),)
FUSE = ON
else
FUSE = OFF
endif

ifneq ($(filter $(DEB_HOST_ARCH),amd64 arm64 mips64el ppc64el riscv64 s390x alpha hurd-amd64 loong64 ppc64 sparc64),)
EC = ON
else
EC = OFF
endif

ifneq ($(filter $(DEB_HOST_ARCH),armel armhf hppa loong64 m68k powerpc sh4),)
POSIX_TEST_BROKEN = 1
else
POSIX_TEST_BROKEN = 0
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

BUILD_DOC = $(if $(filter xrootd-doc,$(shell dh_listpackages)),TRUE,FALSE)

%:
	dh $@ --with python3 --buildsystem cmake

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DFORCE_ENABLED:BOOL=ON \
	    -DENABLE_TESTS:BOOL=ON \
	    -DENABLE_FUSE:BOOL=$(FUSE) \
	    -DENABLE_CEPH:BOOL=$(CEPH) \
	    -DENABLE_XRDEC:BOOL=$(EC) \
	    -DPIP_OPTIONS="--no-deps --use-pep517 --no-build-isolation --disable-pip-version-check --verbose"

override_dh_auto_build:
	dh_auto_build
	[ "$(BUILD_DOC)" = "FALSE" ] || ( \
	doxygen Doxyfile && \
	sed 's!src=".*/xrootd-logo.png"!src="xrootd-logo.png"!' \
	    -i doxydoc/html/index.html && \
	cp -p docs/images/xrootd-logo.png doxydoc/html )

override_dh_auto_test:
	[ -r tests/XRootD/common.cfg.save ] || \
	    cp -p tests/XRootD/common.cfg tests/XRootD/common.cfg.save

	# Reduce socket path lengths used during tests
	# Tests fail with sockets in the build directory if path is too long
	mktemp -d -p /var/tmp > adminpath

	sed "s!all.adminpath .*!all.adminpath $$(cat adminpath)/XRootD!" \
	    -i tests/XRootD/common.cfg

	for x in authenticated_cluster badredir cluster TPCTests xcachewithcsi ; do \
	    sed "s!all.adminpath .*!all.adminpath $$(cat adminpath)/$${x}!" \
		-i obj-$(DEB_HOST_GNU_TYPE)/tests/$${x}/common.cfg ; \
	done

	# The XRootD::cluster::test fails the http protocol tests on some hosts
	# https://github.com/xrootd/xrootd/issues/2464

	# The badredir test fails when there is no network - exclude

	# The posix test is broken for 32 bit archs with 64 bit time_t ...
	# https://github.com/xrootd/xrootd/issues/2559
	# ... and for loong64
	# https://github.com/xrootd/xrootd/issues/2560

	touch testfile
	if ( setfattr -n user.testattr -v testvalue testfile ) ; then \
	    if [ $(POSIX_TEST_BROKEN) -eq 1 ] ; then \
		POSIXTEST='XRootD::posix::test|' ; \
	    fi ; \
	    HOSTNAME=localhost \
	    dh_auto_test -- ARGS+="-E '\
$${POSIXTEST}\
XRootD::authenticated_cluster::test|\
XRootD::badredir|\
XRootD::cluster::test'" ; \
	else \
	    echo "Extended file attributes not supported by file system" ; \
	    echo "Don't run tests that require them" ; \
	    HOSTNAME=localhost \
	    dh_auto_test -- ARGS+="-E '\
XrdCl::FileCopyTest|\
XrdCl::FileSystemTest.PlugInTest|\
XrdCl::FileSystemTest.ServerQueryTest|\
XrdCl::FileSystemTest.XAttrTest|\
XrdCl::FileTest.XAttrTest|\
XrdCl::LocalFileHandlerTest.XAttrTest|\
XrdCl::ThreadingTest|\
XrdCl::WorkflowTest.CheckpointTest|\
XrdCl::WorkflowTest.XAttrWorkflowTest|\
XrdEc::XrdEcTests|\
XRootD::authenticated_cluster::test|\
XRootD::badredir|\
XRootD::cluster::test|\
XRootD::http::test|\
XRootD::posix::test|\
XRootD::tpc::test'" ; \
	fi

	rm testfile
	mv tests/XRootD/common.cfg.save tests/XRootD/common.cfg
	rm -rf $$(cat adminpath)
	rm adminpath

override_dh_auto_clean:
	rm -f testfile
	[ -r tests/XRootD/common.cfg.save ] && \
	    mv tests/XRootD/common.cfg.save tests/XRootD/common.cfg || :
	[ -r adminpath ] && rm -rf $$(cat adminpath) || :
	rm -f adminpath
	dh_auto_clean

override_dh_auto_install:
	ln -sf libxrootd-private-dev.install.ec-$(EC) \
	   debian/libxrootd-private-dev.install

	DEB_PYTHON_INSTALL_LAYOUT=deb \
	_PYTHON_HOST_PLATFORM=$(DEB_HOST_ARCH_OS)-$(DEB_HOST_GNU_CPU) \
	dh_auto_install

	rm -f debian/tmp/usr/lib/*/libXrdCephPosix.so

	rm -f debian/tmp/usr/bin/xrdshmap

	rm -f debian/tmp/usr/lib/python3/dist-packages/xrootd-*.*-info/direct_url.json

	rm -f debian/tmp/usr/lib/*/cmake/XRootD/uninstall.cmake

	[ "$(BUILD_DOC)" = "FALSE" ] || ( \
	LD_LIBRARY_PATH=$${LD_LIBRARY_PATH}:$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) \
	PYTHONPATH=$(CURDIR)/debian/tmp/usr/lib/python3/dist-packages \
	PYTHONDONTWRITEBYTECODE=1 \
	make -C bindings/python/docs html && \
	mv bindings/python/docs/build/html bindings/python/docs/build/python )

	# Service unit files
	mkdir -p debian/tmp/usr/lib/systemd/system
	install -m 644 packaging/common/xrootd@.service debian/tmp/usr/lib/systemd/system
	install -m 644 packaging/common/xrootd@.socket debian/tmp/usr/lib/systemd/system
	install -m 644 packaging/common/xrdhttp@.socket debian/tmp/usr/lib/systemd/system
	install -m 644 packaging/common/cmsd@.service debian/tmp/usr/lib/systemd/system
	install -m 644 packaging/common/frm_xfrd@.service debian/tmp/usr/lib/systemd/system
	install -m 644 packaging/common/frm_purged@.service debian/tmp/usr/lib/systemd/system
	mkdir -p debian/tmp/usr/lib/tmpfiles.d
	install -m 644 packaging/rhel/xrootd.tmpfiles debian/tmp/usr/lib/tmpfiles.d/xrootd.conf
	mkdir -p debian/tmp/usr/lib/sysusers.d
	install -m 644 packaging/rhel/xrootd-sysusers.conf debian/tmp/usr/lib/sysusers.d/xrootd.conf

	# Server config
	mkdir -p debian/tmp/etc/xrootd
	install -m 644 -p packaging/common/xrootd-clustered.cfg \
	    debian/tmp/etc/xrootd/xrootd-clustered.cfg
	install -m 644 -p packaging/common/xrootd-standalone.cfg \
	    debian/tmp/etc/xrootd/xrootd-standalone.cfg
	install -m 644 -p packaging/common/xrootd-filecache-clustered.cfg \
	    debian/tmp/etc/xrootd/xrootd-filecache-clustered.cfg
	install -m 644 -p packaging/common/xrootd-filecache-standalone.cfg \
	    debian/tmp/etc/xrootd/xrootd-filecache-standalone.cfg
	sed 's!/usr/lib64/!!' packaging/common/xrootd-http.cfg > \
	    debian/tmp/etc/xrootd/xrootd-http.cfg

	# Client config
	mkdir -p debian/tmp/etc/xrootd/client.plugins.d
	install -m 644 -p packaging/common/client.conf \
	    debian/tmp/etc/xrootd/client.conf
	sed 's!/usr/lib/!!' packaging/common/client-plugin.conf.example > \
	    debian/tmp/etc/xrootd/client.plugins.d/client-plugin.conf.example
	sed -e 's!/usr/lib64/!!' -e 's!-5!!' packaging/common/recorder.conf > \
	    debian/tmp/etc/xrootd/client.plugins.d/recorder.conf
	sed 's!/usr/lib64/!!' packaging/common/http.client.conf.example > \
	    debian/tmp/etc/xrootd/client.plugins.d/xrdcl-http-plugin.conf

	chmod 644 debian/tmp/usr/share/xrootd/utils/XrdCmsNotify.pm
	sed 's!/usr/bin/env perl!/usr/bin/perl!' -i \
	    debian/tmp/usr/share/xrootd/utils/netchk \
	    debian/tmp/usr/share/xrootd/utils/XrdCmsNotify.pm \
	    debian/tmp/usr/share/xrootd/utils/XrdOlbMonPerf

	sed 's!/usr/bin/env bash!/bin/bash!' -i \
	    debian/tmp/usr/bin/xrootd-config

	mkdir -p debian/tmp/etc/xrootd/config.d

	mkdir -p debian/tmp/var/log/xrootd
	mkdir -p debian/tmp/var/spool/xrootd

	mkdir -p debian/tmp/etc/logrotate.d
	install -m 644 -p packaging/common/xrootd.logrotate \
	    debian/tmp/etc/logrotate.d/xrootd

## xrootd 5.9.1

=== debian/changelog ===
xrootd (5.9.1-3) unstable; urgency=medium

  * Use longer token lifetime during tests (backport from upstream)
  * Adjust some test timeouts

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Sat, 29 Nov 2025 07:40:54 +0100

xrootd (5.9.1-2) unstable; urgency=medium

  * Drop FUSE support (Closes: #1094464, #1121186 )

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Thu, 27 Nov 2025 10:19:48 +0100

xrootd (5.9.1-1) unstable; urgency=medium

  * Update to version 5.9.1

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Tue, 18 Nov 2025 11:12:28 +0100

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,6 @@
  dh-python,
  cmake,
  pkgconf,
- libfuse-dev [linux-any kfreebsd-any],
  libkrb5-dev,
  libcurl4-openssl-dev,
  libtinyxml-dev,
@@ -122,13 +121,15 @@
  libxrdcephposix0 [i386 armel armhf mips mipsel powerpc],
  xrootd-ceph-plugins [i386 armel armhf mips mipsel powerpc],
  libxrdec1t64 [armel armhf m68k sh4],
- libxrdec1 [armel armhf m68k sh4]
+ libxrdec1 [armel armhf m68k sh4],
+ xrootd-fuse
 Breaks:
  libxrdutils3 (<< ${source:Version}),
  libxrdcephposix0 [i386 armel armhf mips mipsel powerpc],
  xrootd-ceph-plugins [i386 armel armhf mips mipsel powerpc],
  libxrdec1t64 [armel armhf m68k sh4],
- libxrdec1 [armel armhf m68k sh4]
+ libxrdec1 [armel armhf m68k sh4],
+ xrootd-fuse
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -373,19 +374,6 @@
  This package contains the command line tools used to communicate with
  xrootd servers.
 
-Package: xrootd-fuse
-Architecture: linux-any kfreebsd-any
-Multi-Arch: foreign
-Depends:
- xrootd-plugins (= ${binary:Version}),
- xrootd-client-plugins (= ${binary:Version}),
- fuse3 (>= 3.10.1-3) | fuse (<< 3),
- ${shlibs:Depends},
- ${misc:Depends}
-Description: Xrootd FUSE tool
- This package contains the FUSE (file system in user space) xrootd mount
- tool.
-
 Package: xrootd-voms-plugins
 Architecture: any
 Multi-Arch: same
@@ -438,3 +426,19 @@
 Provides:
  ${python3:Provides}
 Depends:
+ xrootd-plugins (= ${binary:Version}),
+ xrootd-client-plugins (= ${binary:Version}),
+ ${python3:Depends},
+ ${shlibs:Depends},
+ ${misc:Depends}
+Description: Python 3 bindings for xrootd
+ This package contains Python 3 bindings for xrootd.
+
+Package: xrootd-doc
+Architecture: all
+Multi-Arch: foreign
+Section: doc
+Depends:
+ ${sphinxdoc:Depends},
+ ${misc:Depends}
+Built-Using:

=== debian/rules ===
--- 
+++ 
@@ -20,12 +20,6 @@
 CEPH = OFF
 endif
 
-ifneq ($(filter $(DEB_HOST_ARCH_OS),linux kfreebsd),)
-FUSE = ON
-else
-FUSE = OFF
-endif
-
 ifneq ($(filter $(DEB_HOST_ARCH),amd64 arm64 mips64el ppc64el riscv64 s390x alpha hurd-amd64 loong64 ppc64 sparc64),)
 EC = ON
 else
@@ -49,7 +43,7 @@
 	dh_auto_configure -- \
 	    -DFORCE_ENABLED:BOOL=ON \
 	    -DENABLE_TESTS:BOOL=ON \
-	    -DENABLE_FUSE:BOOL=$(FUSE) \
+	    -DENABLE_FUSE:BOOL=OFF \
 	    -DENABLE_CEPH:BOOL=$(CEPH) \
 	    -DENABLE_XRDEC:BOOL=$(EC) \
 	    -DPIP_OPTIONS="--no-deps --use-pep517 --no-build-isolation --disable-pip-version-check --verbose"
